unit Unit_affiche_correlations;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, Grids,UnitScaleFont,Unit_saisie_correlation,UChaines;

type

  { TForm_affiche_correlations }

  TForm_affiche_correlations = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    StringGrid_correlations: TStringGrid;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StringGrid_correlationsKeyPress(Sender: TObject; var Key: char);
    procedure StringGrid_correlationsMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure StringGrid_correlationsMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid_correlationsPrepareCanvas(sender: TObject; aCol,
      aRow: Integer; aState: TGridDrawState);
  private      encreation:boolean;
    { private declarations }
  public
    { public declarations }
  end;

var
  Form_affiche_correlations: TForm_affiche_correlations;

implementation
 uses unit1;
{ TForm_affiche_correlations }

procedure TForm_affiche_correlations.FormCreate(Sender: TObject);
begin
  encreation:=true;
  caption:=rsCorrLationsE;
  label1.Caption:=rsCoefficientD;
  label2.Caption:=rsCovariance;
  bitbtn2.Caption:=rsPeuplerDeCoe;
  bitbtn3.Caption:=rsPeuplerDeCoe2;
  bitbtn4.Caption:=rsPeuplerDeCoe3;

end;

procedure TForm_affiche_correlations.BitBtn2Click(Sender: TObject);
var i,j:integer;
begin
for i:=1 to nombre_distributions do
for j:=1 to nombre_distributions do
if i<>j then begin
liste_descripteur_correlation[i-1,j-1].valeur:=1;
liste_descripteur_correlation[i-1,j-1].t_correlation:=c_correlation;
StringGrid_correlations.Cells[i,j]:=floattostr(liste_descripteur_correlation[i-1,j-1].valeur);
end;
 StringGrid_correlations.AutoAdjustColumns;
end;

procedure TForm_affiche_correlations.BitBtn3Click(Sender: TObject);
var i,j:integer;
begin
for i:=1 to nombre_distributions do
for j:=1 to nombre_distributions do
if i<>j then begin
liste_descripteur_correlation[i-1,j-1].valeur:=-1;
liste_descripteur_correlation[i-1,j-1].t_correlation:=c_correlation;
StringGrid_correlations.Cells[i,j]:=floattostr(liste_descripteur_correlation[i-1,j-1].valeur);
end;
 StringGrid_correlations.AutoAdjustColumns;

end;

procedure TForm_affiche_correlations.BitBtn4Click(Sender: TObject);
var i,j:integer;
begin
for i:=1 to nombre_distributions do
for j:=1 to nombre_distributions do
if i<>j then begin
liste_descripteur_correlation[i-1,j-1].valeur:=0;
liste_descripteur_correlation[i-1,j-1].t_correlation:=c_correlation;
StringGrid_correlations.Cells[i,j]:=floattostr(liste_descripteur_correlation[i-1,j-1].valeur);
end;
 StringGrid_correlations.AutoAdjustColumns;

end;

procedure TForm_affiche_correlations.FormShow(Sender: TObject);
begin
 // if encreation then begin scalefont(self); encreation:=false; end;

end;

procedure TForm_affiche_correlations.StringGrid_correlationsKeyPress(
  Sender: TObject; var Key: char);
begin
   if key=',' then key:='.';
end;

procedure TForm_affiche_correlations.StringGrid_correlationsMouseDown(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var colonne,ligne:integer;
   begin

        StringGrid_correlations.MouseToCell(x,y,colonne,ligne);

  if (colonne>0) and (ligne>0) and (colonne<>ligne) then begin

    with  Form_saisie_correlation do begin
     if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
   if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
   edit1.text:=floattostr(liste_descripteur_correlation[colonne-1,ligne-1].valeur);
   if  liste_descripteur_correlation[colonne-1,ligne-1].t_correlation=c_correlation
   then radiogroup1.itemindex:=0 else radiogroup1.itemindex:=1;
   caption:=Format(rsCorrLationEn, [liste_distributions[colonne-1
     ].nom_variable, liste_distributions[ligne-1].nom_variable]);
         end;

    if  Form_saisie_correlation.ShowModal=mrok then begin
    liste_descripteur_correlation[colonne-1,ligne-1].valeur:=Unit_saisie_correlation.valeur_corr;
    if Form_saisie_correlation.RadioGroup1.ItemIndex=0 then
    liste_descripteur_correlation[colonne-1,ligne-1].t_correlation:=c_correlation else
      liste_descripteur_correlation[colonne-1,ligne-1].t_correlation:=c_covariance;
                     liste_descripteur_correlation[ligne-1,colonne-1].valeur:=liste_descripteur_correlation[colonne-1,ligne-1].valeur;
               liste_descripteur_correlation[ligne-1,colonne-1].t_correlation:=liste_descripteur_correlation[colonne-1,ligne-1].t_correlation;

    StringGrid_correlations.Cells[colonne,ligne]:=floattostr(liste_descripteur_correlation[colonne-1,ligne-1].valeur);
    StringGrid_correlations.Cells[ligne,colonne]:=floattostr(liste_descripteur_correlation[ligne-1,colonne-1].valeur);
    StringGrid_correlations.AutoAdjustColumns;
      end;

    end;




end;

procedure TForm_affiche_correlations.StringGrid_correlationsMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
var coco,roro:integer;  chaine:string;
begin
   if (StringGrid_correlations.cursor=crvsplit) or
     (StringGrid_correlations.cursor=crhsplit ) then exit;

  StringGrid_correlations.MouseToCell(x,y,coco,roro);
    chaine:='';
  if (coco>0) and (roro>0) and (coco<>roro) then

  chaine:=rsClicIciPourM6;
   if chaine<> StringGrid_correlations.Hint then begin
   StringGrid_correlations.Hint:=chaine;
  Application.ActivateHint(Mouse.CursorPos);
    End;
end;

procedure TForm_affiche_correlations.StringGrid_correlationsPrepareCanvas(
  sender: TObject; aCol, aRow: Integer; aState: TGridDrawState);
var i,j:integer;    MyTextStyle: TTextStyle;
begin

 StringGrid_correlations.Canvas.Brush.Style:= bssolid;
 MyTextStyle:=  StringGrid_correlations.Canvas.TextStyle;
 MyTextStyle.Alignment:=tacenter;
 StringGrid_correlations.Canvas.TextStyle := MyTextStyle;
 if (acol>0) and (arow>0) and (acol<>arow) and (liste_descripteur_correlation[acol-1,arow-1].t_correlation=c_correlation) then
 begin
 StringGrid_correlations.Canvas.font.Color:=clblue;
 StringGrid_correlations.Canvas.font.Style:= StringGrid_correlations.Canvas.font.Style+[fsbold];
 end;

 if (acol>0) and (arow>0) and (acol<>arow) and (liste_descripteur_correlation[acol-1,arow-1].t_correlation=c_covariance) then
 begin
 StringGrid_correlations.Canvas.font.Color:=clgreen;
 StringGrid_correlations.Canvas.font.Style:= StringGrid_correlations.Canvas.font.Style+[fsbold];
 end;
 if ((acol>0) and (arow>0) and (acol=arow)) then begin
   StringGrid_correlations.Canvas.Brush.Style:= bsFDiagonal;
   StringGrid_correlations.Canvas.Brush.Color :=clblack;
   end;

end;

initialization
  {$I unit_affiche_correlations.lrs}

end.

